//+------------------------------------------------------------------+
//|                                            Fractals_Malagant.mq4 |
//|         Copyright  2004, by Malagant Killerprom Corporation     |
//|                                        http://www.mql4.com/ru    |
//+------------------------------------------------------------------+
#property copyright "Copyright  2004, by Malagant"
#property link      "www.mql4.com/ru"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 SeaGreen
#property indicator_color2 Red
//----  
extern int Fractal_Number = 9;
//---- buffers
double FractalsUp[];
double FractalsDown[];
//----
int pos = 0, cntup = 0, cntdown = 0, cnt = 0;
int r = 0, l = 0, e = 0;
int fup = 0, fdown = 0;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexBuffer(0, FractalsUp);
   SetIndexBuffer(1, FractalsDown);   
//----
   SetIndexStyle(0, DRAW_ARROW, 0, 2);
   SetIndexArrow(0, 159);
//----
   SetIndexStyle(1, DRAW_ARROW, 0, 2);
   SetIndexArrow(1, 159);
//----
   cntup = (Fractal_Number-1)/2 + (Fractal_Number-1)/2 + Fractal_Number + 1;
   cntdown = (Fractal_Number-1)/2 + Fractal_Number + 1;
   if(cntup >= cntdown) 
       cnt = cntup;
   if(cntup < cntdown)  
       cnt = cntdown; 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int i=0, j=0;
   int cbars = IndicatorCounted();
//----
   if(cbars < 0) 
       return(-1);
//----
   if(cbars > 0) 
       cbars--;
   pos = 0;
//----
   if(cbars > (Bars - cnt - 1)) 
       pos =(Bars - cnt - 1);
   else 
       pos = Bars - (cbars + (Fractal_Number-1)/2);
//----
   while(pos >= (Fractal_Number-1)/2)
     {
       FractalsUp[pos] = NULL;
       FractalsDown[pos] = NULL;     
       // 
       r = (Fractal_Number-1)/2; //   
       //----
       for(i = 1; i <= r; i++)
         {
           if(High[pos] <= High[pos-i]) 
               break;
         }
       //     i    r+1
       if(i == r + 1) //FractalsUp[pos]=High[pos];
         {
           l = (Fractal_Number-1)/2;  //   
           e = Fractal_Number;
           //----
           for(j = 1; j <= l + Fractal_Number; j++)
             {     
               if(High[pos] < High[pos+j]) 
                   break;
               //----
               if(High[pos] > High[pos+j]) 
                   l--;
               //----
               if(High[pos] == High[pos+j])
                   e--;
               //----
               if(l == 0) 
                 {
                   FractalsUp[pos] = High[pos];
                   break;
                 }
               //----
               if(e < 0) 
                   break;
             }
         }
       // 
       r = (Fractal_Number-1)/2; //   
       //----
       for(i = 1; i <= r; i++)
         {
           if(Low[pos] >= Low[pos-i]) 
               break;
         }     
       //----
       if(i == r + 1) //FractalsUp[pos]=High[pos];
         {
           l = (Fractal_Number-1)/2;  //   
           e = Fractal_Number;
           //----
           for(j = 1; j <= l + Fractal_Number; j++)
             {      
               if(Low[pos] > Low[pos+j]) 
                   break;
               //----
               if(Low[pos] < Low[pos+j]) 
                   l--;
               //----
               if(Low[pos] == Low[pos+j])
                   e--;
               //----
               if(l == 0) 
                 {
                   FractalsDown[pos] = Low[pos];
                   break;
                 }
               if(e < 0) 
                   break;
             }
         }
       pos--;
     }
//----
   return(0);
  }
//+------------------------------------------------------------------+